/* A collection of modules. */

exports.Collection = Collection;
function Collection() {
  this._collection = [];
}

(function(p) {
  p.add = add;
  function add(m) {
    if (this.contains(m)) { return; }
    this._collection[m.id] = m;
  }

  p.contains = contains;
  function contains(m) {
    return (m.id in this._collection);
  }

  p.toArray = toArray;
  function toArray() {
    return Object.keys(this._collection).map(function(id) {
      return this._collection[id];
    }, this);
  }

  p.getLength = getLength;
  function getLength() {
    return Object.keys(this._collection).length;
  }

  p.isEmpty = isEmpty;
  function isEmpty() {
    return this.getLength() === 0;
  }
})(Collection.prototype);

exports.createCollection = createCollection;
exports.create = createCollection;
function createCollection() {
  return new Collection();
}